/*
 * Copyright (c) 2019 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

#ifndef LOG_HPP__
#define LOG_HPP__

enum class LogMsgType {
	INFO,
	WARNING,
	ERROR
};

class Logger {
 public:
	void log(const LogMsgType type, const char *fmt...);
};

#define log_info(fmt, args...)    log(LogMsgType::INFO, fmt, ##args)
#define log_warning(fmt, args...) log(LogMsgType::WARNING, fmt, ##args)
#define log_error(fmt, args...)   log(LogMsgType::ERROR, fmt, ##args)

extern Logger logger;

#endif  // LOG_HPP__
